package net.minecraft.src;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import org.lwjgl.input.Mouse;

import net.minecraft.client.Minecraft;

public class GuiResidentsList extends GuiScreen
{
    private EntityPlayer player;
    private static boolean checked = false;
    protected String screenTitle = "ResidentsList";
    protected GuiSlot selectPanel;
    private GuiButton localScroll;
	public ArrayList<EntityNameplate> nameplateListDistance;

    public GuiResidentsList(World var1, EntityPlayer parPlayer)
    {
        this.player = parPlayer;
    	
        // Nameplateを近い順に並べる
        nameplateListDistance = (ArrayList<EntityNameplate>)(mod_Nameplate.NameplateList.clone());
    	// ownerの無いものを削除
    	Iterator<EntityNameplate> iterator = nameplateListDistance.listIterator();
    	while(iterator.hasNext())
    	{
    		EntityNameplate var2 = iterator.next();
    		if(var2.entityOwner == null) iterator.remove();
    	}
    	// ソート
        Collections.sort(nameplateListDistance, new NameplateDistanceComparator(player));
    }

    /**
     * Adds the buttons (and other controls) to the screen in question.
     */
    public void initGui()
    {
        StringTranslate var1 = StringTranslate.getInstance();
        this.selectPanel = new GuiResidentsListSlot(this.mc, this, this.player);
        this.selectPanel.registerScrollButtons(this.controlList, 3, 4);
        this.localScroll = new GuiButton(3, 0, 0, "");
        this.controlList.add(new GuiButton(200, this.width / 2 - 60, this.height - 40, 120, 20, var1.translateKey("gui.done")));
    }

    /**
     * Fired when a control is clicked. This is the equivalent of ActionListener.actionPerformed(ActionEvent e).
     */
    protected void actionPerformed(GuiButton var1)
    {
        if (var1.enabled)
        {
            if (var1.id == 200)
            {
                this.mc.displayGuiScreen((GuiScreen)null);
            }
        }
    }

    /**
     * Draws the screen and all the components in it.
     */
    public void drawScreen(int var1, int var2, float var3)
    {
        this.drawDefaultBackground();
        this.selectPanel.drawScreen(var1, var2, var3);
        this.drawCenteredString(this.fontRenderer, this.screenTitle, this.width / 2, 20, 16777215);
        super.drawScreen(var1, var2, var3);
    }

    /**
     * Returns true if this GUI should pause the game when it is displayed in single-player
     */
    public boolean doesGuiPauseGame()
    {
        return true;
    }

    /**
     * Handles mouse input.
     */
    public void handleMouseInput()
    {
        super.handleMouseInput();
        int var1 = Mouse.getEventDWheel();

        if (var1 != 0)
        {
            this.localScroll.id = var1 > 0 ? 3 : 4;
            this.selectPanel.actionPerformed(this.localScroll);
        }
    }
}

class NameplateDistanceComparator implements java.util.Comparator {
    EntityPlayer player;

    public NameplateDistanceComparator(EntityPlayer parPlayer)
    {
        player = parPlayer;
    }

    public int compare(Object s, Object t) {
        EntityLiving so = ((EntityNameplate) s).entityOwner;
        EntityLiving to = ((EntityNameplate) t).entityOwner;
        if(so == null && to == null) return 0;
        else if(so == null) return 1;
        else if(to == null) return -1;
        return (int)(Math.ceil(player.getDistanceToEntity(so) - player.getDistanceToEntity(to)));
    }
}
